// VELUX.dcl
// VELUX Austria only
// PAUsoft
// Paule Riviere

// dcl_settings : default_dcl_settings { audit_level = 3; }

// ----------------------------------------------------------------------------
// common DCL 
// ----------------------------------------------------------------------------
box_3  : edit_box {alignment = right;edit_width = 3;}
lis_12 : popup_list {fixed_width  = true;alignment = right;width = 12;}
lis_22 : popup_list {fixed_width  = true;alignment = right;width = 22;}
lis_28 : popup_list {alignment = right;width = 28;}
mat1_dat: row {
          : column {
            : text {value = "Material:";fixed_width = true;width = 11;}
            : text {value = "Stock/Flgel:";fixed_width = true;width = 11;}}
          : spacer {width = 3;}
          : paragraph {
            : concatenation {
              : popup_list {key = "mat1";fixed_width = true;alignment = right;width = 28;}
              spacer_0; }}}
mat2_dat: row {
            : text {value = "Auenverblechung:";fixed_width = true;width = 15;}
          : paragraph {
            : concatenation {
              : popup_list {key = "mat2";fixed_width = true;alignment = right;width = 28;}
              spacer_0; }}}
typ : popup_list {fixed_width  = true;alignment = right;width = 28;}
siz : popup_list {fixed_width  = true;alignment = right;width = 18;}
cod : text {fixed_width  = true;alignment = centered;width = 15;}
typ_txt : column {
          fixed_width  = true;
          : spacer {height = 1;}
          : text {value = "ffnungstyp:";fixed_width = true;width = 11;}
          : text {value = "Grsse BxH:";fixed_width = true;width = 11;}
          : text {value = "Typencode:";fixed_width = true;width = 11;}}
typ_dat_1 : boxed_column {
            fixed_width  = true;
            : typ {key = "type1";}
            : siz {key = "size1";}
            : cod {key = "code1";}}
typ_dat_2 : boxed_column {
            fixed_width  = true;
            : typ {key = "type2";}
            : siz {key = "size2";}
            : cod {key = "code2";}}
typ_dat_3 : boxed_column {
            fixed_width  = true;
            : typ {key = "type3";}
            : siz {key = "size3";}
            : cod {key = "code3";}}
typ_dat_4 : boxed_column {
            fixed_width  = true;
            : typ {key = "type4";}
            : siz {key = "size4";}
            : cod {key = "code4";}}
typ_dat_5 : boxed_column {
            fixed_width  = true;
            : typ {key = "type5";}
            : siz {key = "size5";}
            : cod {key = "code5";}}
typ_dat_6 : boxed_column {
            fixed_width  = true;
            : typ {key = "type6";}
            : siz {key = "size6";}
            : cod {key = "code6";}}
txt_lin_2 : column {
            : text {key = "txt-lin-1";}
            : text {key = "txt-lin-2";}}
vx_bot : column {
         fixed_width = true;
         alignment = centered;
         : button {key = "fla_lin";alignment = centered;fixed_width  = true;
                   label = "Dach- und Raumanschlussprodukte";}
         : button {key = "acc";alignment = centered;fixed_width  = true;
                   label = "Hitzeschutz/Dekorationsprodukte";}
         errtile;
         ok_cancel;}
// ----------------------------------------------------------------------------
// velux-ins & velux-edi i velux.lsp
// ----------------------------------------------------------------------------
vx_ins_a : dialog {
  label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : row {
    : boxed_column {
        : image {key = "ima";width = 20;height = 10;color = -15;}}
    : column {
      : row {
        : column {
          : spacer {height = 3;}
          spacer;
          : text {value = "Dachneigung:";fixed_width  = true;width = 12;}
          : text {value = "Darstellung:";fixed_width  = true;width = 12;}
          : text {value = "Einbau:     ";fixed_width  = true;width = 12;} }
        : column {
          : row {
            : spacer {width = 5;}
            : image {key = "lgo";alignment = right;width = 5;height = 3; color = -15;}
            }
          : row {
            : edit_box {key = "pit";edit_width = 3;alignment = left;fixed_width  = true;}
            : text {value = "";alignment = left;width = 1;fixed_width  = true;}
            : spacer {width = 20;}}
          : popup_list {key = "sec";alignment = left;width = 29;fixed_width  = true;}
          : popup_list {key = "ima-txt";alignment = left;width = 29;fixed_width  = true;} } }
      : row {
        : button {key = "pro";label = "Produktauswahl";alignment = centered;} } }}
  : text {value = " ";fixed_width  = true;width = 10;}
  : text {value = "HINWEIS: ";fixed_width  = true;width = 30;}
  : text {value = "Einfgepunkt liegt auf Niveau Ziegellattenoberkante entspricht VELUX Rote Linie.";fixed_width  = true;width = 70;}
  errtile;
  ok_cancel;}
// ----------------------------------------------------------------------------
vx_ins_a_test : dialog {
  label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : row {
    : boxed_column {
        : image {key = "ima";width = 20;height = 10;color = -15;}}
    : column {
      : row {
        : column {
          : spacer {height = 3;}
          spacer;
          : text {value = "Dachneigung:";fixed_width  = true;width = 12;}
          : text {value = "Darstellung:";fixed_width  = true;width = 12;}
          : text {value = "Einbau:     ";fixed_width  = true;width = 12;} }
        : column {
          : row {
            : spacer {width = 5;}
            : image {key = "lgo";alignment = right;width = 5;height = 3; color = -15;}
            }
          : row {
            : edit_box {key = "pit";edit_width = 3;alignment = left;fixed_width  = true;}
            : text {value = "";alignment = left;width = 1;fixed_width  = true;}
            : spacer {width = 20;}}
          : popup_list {key = "sec";alignment = left;width = 29;fixed_width  = true;}
          : popup_list {key = "ima-txt";alignment = left;width = 29;fixed_width  = true;} } }
      : row {
        : button {key = "pro";label = "Produktauswahl";alignment = centered;} } }}
  : text {value = " ";fixed_width  = true;width = 10;}
  : text {value = "HINWEIS: ";fixed_width  = true;width = 30;}
  : text {value = "Einfgepunkt liegt auf Niveau Ziegellattenoberkante entspricht VELUX Rote Linie.";fixed_width  = true;width = 70;}
  : row {
    : popup_list {key = "tga-1";alignment = left;width = 30;fixed_width  = true;}  
    : popup_list {key = "tga-2";alignment = right;width = 30;fixed_width  = true;}}  
  : row {
    : popup_list {key = "tga-3";alignment = left;width = 30;fixed_width  = true;}  
    : popup_list {key = "tga-4";alignment = right;width = 30;fixed_width  = true;}}  
  errtile;
  ok_cancel;}
// ----------------------------------------------------------------------------
// vx-0 i velux.lsp
// ----------------------------------------------------------------------------
vx_0_a : dialog {
   label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : row {: text {width = 40; key = "txt-head";}}
  : row {
    : column {
      : boxed_row {
        : image {key = "ima1";fixed_width = true;width  = 20;height = 7;color  = -15;}}
      spacer;}
    : column {
      mat1_dat;
      : row {
        typ_txt;
        typ_dat_1;}
      mat2_dat;}}
  : spacer {height = 1;}
  txt_lin_2;
  vx_bot;}
// ----------------------------------------------------------------------------
// vx-4 i velux.lsp
// ----------------------------------------------------------------------------
vx_4_a : dialog {
  label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : row {: text {width = 40; key = "txt-head";}}
  : row {
    : column {
      : boxed_row {
        : image {key = "ima1";fixed_width = true;width  = 37;height = 10;color  = -15;}}
      : paragraph {
        : column {
          : text {value = "Fensterauswahl REIHE 2,3,4...";fixed_width  = true;width = 20;}
          : row {
            : text {value = "Anzahl darberliegend:";fixed_width  = true;width = 20;}
            : popup_list {key = "count-b";fixed_width = true;alignment = right;width = 1;}}}
        : row {
          : text {value = "Abstand bereinander:";fixed_width  = true;width = 20;}
          : popup_list {key = "dist-b";fixed_width = true;alignment = right;width = 15;}}
        : text {value = "Fr Rollladeneinbau 250 mm notwendig!";fixed_width  = true;width = 30;}}
      spacer;
      : paragraph {
        : column {
          : text {value = "Fensterauswahl REIHE 1:";fixed_width  = true;width = 20;}
          : row {
            : text {value = "Anzahl nebeneinander:";fixed_width  = true;width = 20;}
            : popup_list {key = "count-a";fixed_width = true;alignment = right;width = 1;}}}
        : row {
          : text {value = "Abstand nebeneinander:";fixed_width  = true;width = 20;}
          : popup_list {key = "dist-a";fixed_width = true;alignment = right;width = 15;}}
        : text {value = "Abstnde zwischen Fensterstockauenma.";fixed_width  = true;width = 30;}}}
    : column {
      : row {
        // EBY can be here !!
        : spacer {height = 8;}}
      mat1_dat;
      : row {
        typ_txt;
        typ_dat_2;}
      : row {
        typ_txt;
        typ_dat_1;}
      mat2_dat;}}
  txt_lin_2;
  vx_bot;}
// ----------------------------------------------------------------------------
// vx-5 & vx-6 i velux.lsp
// ----------------------------------------------------------------------------
vx_56_a : dialog {
  label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : row {: text {width = 40; key = "txt-head";}}
  : row {
    : column {
      : boxed_row {
        : image {key = "ima1";fixed_width = true;width  = 22;height = 14;color  = -15;}{}}
      spacer;}
    : column {
      mat1_dat;
      : row {
        typ_txt;
        typ_dat_2;}
      : row {
        typ_txt;
        typ_dat_1;}
       mat2_dat;}}
  : spacer {height = 1;}
  txt_lin_2;
  vx_bot;}
// ----------------------------------------------------------------------------
// vx-7 & vx-8 i velux.lsp
// ----------------------------------------------------------------------------
vx_78_a : dialog {
  label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : row {: text {width = 40; key = "txt-head";}}
  : row {
    : column {
      : spacer {height = 9;}
      mat1_dat;}
    : column {
      : spacer {width = 6;}}
    : column {
      : boxed_row {
        : image {key = "ima1";fixed_width = true;width  = 30;height = 10;color  = -15;} }}
    : column {
      : spacer {width = 3;}}
      }
  : row {      
    : column {
      typ_txt;
      typ_txt;}
    : column {
      : spacer {width = 4;}}
  
    : column {
      typ_dat_4;
      typ_dat_1;}
    : column {
      typ_dat_5;
      typ_dat_2;}
    : column {
      typ_dat_6;
      typ_dat_3;}}
   : row {
      mat2_dat;
      : spacer {width = 3;}
      : column {
        : row {
          : text {value = "Abstand nebeneinander:";fixed_width  = true;width = 20;}
          : popup_list {key = "dist-a";fixed_width = true;alignment = right;width = 15;}}
        }
   }
  spacer;
 // txt_lin_2;
  vx_bot;}
// ----------------------------------------------------------------------------
// Flashing  &  LININGS
// ----------------------------------------------------------------------------
vx_fla_lin_a : dialog {
  label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : text {width = 40; value = "Dach- und Raumanschlussprodukte";}
  spacer;
  : row {
    : column {
      : boxed_column {
        : text {value = "EINDECKRAHMEN fr Dachmaterial";fixed_width = true;width = 30;}
        : radio_column {
          : radio_button {key = "pro";label = "wellig ab 16 mm";fixed_width = true;width = 20;}
          : radio_button {key = "fla";label = "flach bis 16 mm";fixed_width = true;width = 20;}
          : radio_button {key = "pla";label = "Stehfalz (Cu,TiZn)";fixed_width = true;width = 20;}
          : radio_button {key = "non";label = "ohne, Spengler bauseits";fixed_width = true;width = 20;} }}
      : boxed_column {
        : text {value = "ANSCHLUSSPAKETE";fixed_width = true;width = 20;}
        : radio_column {
          : radio_button {key = "xx1";label = "Profi Set Plus - BFX, LGI, BBX";fixed_width = true;width = 26;}
          : radio_button {key = "xx2";label = "Profi Set - BFX, LGI";fixed_width = true;width = 20;}
          : radio_button {key = "xx3";label = "Einzelkomponenten";fixed_width = true;width = 20;} }}
      : boxed_column {
        : text {value = "DACHSEITIG";fixed_width = true;width = 20;}
        : concatenation {: toggle {key = "bfx";}
                         : column {
                           : text {value = "Unterdachschrze BFX";fixed_width = true;width = 20;}
                           : text {value = "Anschluss Unterdach";fixed_width = true;width = 20;}}}
        : text {value = "RAUMSEITIG";fixed_width = true;width = 20;}
        : concatenation {: toggle {key = "lgi";}
                         : column {
                           : text {value = "Fensterstockverlngerung LGI";fixed_width = true;width = 26;}
                           : text {value = "Anschluss Wrmedmmung";fixed_width = true;width = 26;}}}
        : concatenation {: toggle {key = "bbx";}
                         : column {
                           : text {value = "Dampfbremsen-Manschette BBX";fixed_width = true;width = 26;}
                           : text {value = "Anschluss Dampfbremse";fixed_width = true;width = 26;}}} }}
    : column {
      : image {key = "ima";fixed_width = true;width  = 40;height = 13;color  = -15;}
      : boxed_column {
        : text {value = "INNENAUSBAUELEMENT";fixed_width = true;width = 25;}
        : concatenation {: toggle {key = "lsc";}
                           : text {value = "Laibung LSC inkl. BBX";fixed_width = true;width = 25;}}
      : row {
      : spacer {width = 3;}
        : image {key = "ima-lsc";fixed_width = true;alignment = left;width  = 23;height = 9;color  = -15;}
      : spacer {width = 9;}
        }
        : text {value = "Dachaufbaustrke bis max. 400 mm:";fixed_width = true;width = 30;}
        : edit_box {key = "rooftik";fixed_width = true;width = 5;}
        : spacer {height = 2;}}
    }}
  errtile;
  ok_cancel;}
// ----------------------------------------------------------------------------
// Accessories
// ----------------------------------------------------------------------------
vx_acc_a : dialog {
  label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : text {value = "Hitzeschutz/Dekoration";fixed_width = true;width = 17;}
  : boxed_column {
    : text {value = "HITZESCHUTZ";fixed_width = true;width = 12;}
    : row {: image {key = "ima-m";width = 6;height = 6;color = -15;}
           : paragraph {: text {value = "Markisette";fixed_width = true;width = 8;}
                        : popup_list {key = "lis-m";alignment = right;width = 8;}
                        : text {key = "cod-m";width = 8;}}}
    : row {: image {key = "ima-s";width = 6;height = 6;color = -15;}
           : paragraph {: text {value = "Rollladen";fixed_width = true;width = 8;}
                        : popup_list {key = "lis-s";alignment = right;width = 8;}
                        : text {key = "cod-s";width = 8;}}} }
  : boxed_column {
    : text {value = "DEKORATION";fixed_width = true;width = 12;}
    : row {: image {key = "ima-a";width = 6;height = 6;color = -15;}
           : paragraph {: popup_list {key = "lis-a";alignment = right;width = 8;}
                        : text {key = "cod-a";width = 8;}}} }
  spacer;
  : text {key = "txt-lin-1";}
  spacer;
  errtile;
  ok_cancel;}
// ---------------------------------------------------------
// Velux Piecelist
// ---------------------------------------------------------
vx_pic_a : dialog {
  label = "www.VELUX.at";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : text {value = "STCKLISTE ERSTELLEN";alignment = centered;width = 20;fixed_width  = true;}
  spacer;
  : text {value = "sortiert nach:";alignment = centered;width = 20;fixed_width  = true;}
  : button {label = "Produkttypen";key = "sty-ty";alignment = centered;width = 20;fixed_width  = true;}
  : button {label = "Grsse";key = "sty-sz";alignment = centered;width = 20;fixed_width  = true;}
  errtile;
  ok_only;}
// ----------------------------------------------------------------------------
vx_pic2_a : dialog {
  label = "www.VELUX.at";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : row {: text {value = "STCKLISTE ERSTELLEN";width = 40;alignment = centered;}}
  : list_box {key = "lin-list";width  = 80;height = 20;tabs   = "5 15 35 55";}
  spacer;
  : row {
    : button {label = "Einfgen in Zeichnung";width = 1;key = "wri";}
    : button {label = "In Datei schreiben";width = 1;key = "sav";}
    }
  errtile;
  ok_only;}
// ---------------------------------------------------------
// Velux Configuration
// ---------------------------------------------------------
vx_cfg_a : dialog {
  label = "www.VELUX.at  => Produktinfos, Objekte...";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  : row {: text {value = "Konfiguration von VELUXCAD";fixed_width  = true;width = 25;}}
  : row {
    : boxed_column {
      : row {
        : column {
          : text {value = "Ein/Aus";fixed_width = true;width = 6;}
          : spacer {height = 11;}
          : toggle {key = "tog-8";}
          spacer_0;
          : toggle {key = "tog-9";}
          spacer_0; }
        : column {
          : row {: text {value = " ";fixed_width = true;width = 5;}
                 : text {value = "Farbe nur 2D";fixed_width = true;width = 15;}}
          : row {: text {value = "Scheibe";fixed_width  = true;width = 20;}
                 : lis_12 {key = "col-1";}: box_3  {key = "col-cfg1";}}
          : row {: text {value = "Flgel/Rahmen";fixed_width  = true;width = 20;}
                 : lis_12 {key = "col-2";}: box_3  {key = "col-cfg2";}}
          : row {: text {value = "Blechteile";fixed_width  = true;width = 20;}
                 : lis_12 {key = "col-3";}: box_3  {key = "col-cfg3";}}
          : row {: text {value = "Dach- u. Raumanschluss";fixed_width  = true;width = 20;}
                 : lis_12 {key = "col-4";}: box_3  {key = "col-cfg4";}}
                 // number 5 out
          : row {: text {value = "Hitzeschutz/Dekoration";fixed_width  = true;width = 20;}
                 : lis_12 {key = "col-6";}: box_3  {key = "col-cfg6";}}
          : row {: text {value = "Rote Linie";fixed_width  = true;width = 20;}
                 : lis_12 {key = "col-7";}: box_3  {key = "col-cfg7";}}
          : row {: text {value = "Schraffur";fixed_width  = true;width = 20;}
                 : lis_12 {key = "col-8";}: box_3  {key = "col-cfg8";}}
          : row {: text {value = "3D Dummysolid";fixed_width  = true;width = 20;}
                 : lis_12 {key = "col-9";}: box_3  {key = "col-cfg9";}} }
        : column {
          : text {value = "Layer";fixed_width = true;width = 10;}
          : lis_28 {key = "lay-cfg1";}
          : lis_28 {key = "lay-cfg2";}
          : lis_28 {key = "lay-cfg3";}
          : lis_28 {key = "lay-cfg4";}
                 // number 5 out
          : lis_28 {key = "lay-cfg6";}
          : lis_28 {key = "lay-cfg7";}
          : lis_28 {key = "lay-cfg8";}
          : lis_28 {key = "lay-cfg9";} }}} }
  : boxed_column {
  : row {
    : toggle {key = "tog-10";}
    : spacer {width = 2;}
    : text   {value = "Typenbezeichnung";fixed_width  = true;width = 20;}
    : lis_12 {key = "col-10";}: box_3 {key = "col-cfg10";}
    : column {: lis_28 {key = "lay-cfg10";}}}
   : row {
    : spacer {width = 6;}
    : text   {value = "Textskalierung";alignment = right;fixed_width = true;width = 20;}
    : spacer {width = 0;}
    : edit_box {key = "sc-txt";alignment = right;edit_width = 5;}
    : spacer {width = 40;}
    }}
  : boxed_row {
    : spacer {width = 5;}
    : text   {value = "Einfgepunkt:";alignment = right;fixed_width = true;width = 12;}
    //: spacer {width = 4;}
    : text   {value = "unten";alignment = right;fixed_width = true;width = 4;}
    : radio_button {key = "bot";}
    //: spacer {width = 8;}
    : text   {value = "oben";alignment = right;fixed_width = true;width = 4;}
    : radio_button {key = "top";}
    : spacer {width = 12;}
    : text   {value = "Maeinheit:";alignment = right;fixed_width = true;width = 9;}
    : popup_list {alignment = right;width     = 8;key = "scale";}}
  errtile;
  ok_cancel;}
// ----------------------------------------------------------------------------
// VELUX INFO
// ----------------------------------------------------------------------------
vx_info_a : dialog {
  label = "www.VELUX.at";
  aspect_ratio = 0;
  fixed_height = true;
  fixed_width  = true;
  spacer;
  : image {key = "lgo";
    height = 3; aspect_ratio = 2.5; color = -15;}
  : text {value = "VELUX CAD 2.4";fixed_width = true;width = 20;}
  : text {value = "VELUX sterreich GmbH";fixed_width = true;width = 20;}
  : text {value = "A-2120 Wolkersdorf";fixed_width = true;width = 20;}
  : text {value = "Tel: 02245/32350";fixed_width = true;width = 20;}
  : text {value = "Fax: 02245/3235 655";fixed_width = true;width = 20;}
  : text {value = "Internet: www.VELUX.at";fixed_width = true;width = 20;}
  : text {value = "E-mail: office.V-A@VELUX.com";fixed_width = true;width = 25;}
  errtile;
  ok_only;}
// ----------------------------------------------------------------------------
// www.pausoft.dk
// ----------------------------------------------------------------------------
