;==============================================================================
;;;
;;; VELUX-2.LSP
;;; PAUsoft (+45 46 18 59 85)
;;;
;==============================================================================
; *****************************************************************************
; *                                                                           *
; *  VELUX-2.LSP                                    User   VELUX              *
; *                                                                           *
; *  Version   1.00 for R2000                       Author  PAU-SOFT          *
;*************************************************************************
;  (prompt (strcat (v-text 9010)(v-text 9020)))

  (prompt "Programm wird geladen.    Bitte warten!    Danke!")

;============================================================================
;*************************************************************************
;    V E L U X         DANNELSE AF 2D VINDUE
;*************************************************************************
(defun ins-2d-v (MIR NR INS-P DCH AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS
                / LLL LLX D-X D-Y A-X A-Y N SS IP PP TOP-
                  SS1 SS-F SS-S SS-V TYP STR PCO GT BRE HOJ
                  FLA-LIS LIN-LIS DSP-LIS
                  PT PPB PL DYY DY DXX PBB DPT DPB SPL)
  (if paucheck (princ "\nins-2d-v"))
  (if (not get-2d-l)(load (strcat VELUX-DIR "velux_2d.lsp")))
  (setq LLL  (car (cadr AFS))
        LLX  0
	D-X  (car (car AFS))
	D-Y  (cadr (car AFS))
	A-X  (caddr (car AFS))
	A-Y  (cadddr (car AFS))
	IP   INS-P
        PP   INS-P
	N    0
	SS   (ssadd))
  (repeat (1+ A-Y)
    (get-data-2 (nth N TGA1-LIS) (nth (+ N A-X) TGA1-LIS))
    (if paucheck (princ (list typ hoj)))
    (if (member NR '(8))
      (if (eq N 0)
        ;(setq IP (list (car IP)(- (cadr IP) HOJ -13)(caddr IP)))
        (setq IP (list (+ (car IP) (* MIR 7))(- (cadr IP) HOJ -23)(caddr IP)))
	(setq IP INS-P)))
    (if (member NR '(6))
      (if (eq N 0)
        (setq VV (if (eq MIR -1)
		   (dtr (- 180 (- DCH 55)))
		   (dtr (- DCH 55)))
	      IP (if (member TYP '("VIU")); ogs rotationspunkt
		   ;(polar (list (+ (* MIR -34)(car IP))(- (cadr IP) 48)(caddr IP)) VV 46.9325)
		   (polar (list (+ (* MIR -34)(car IP))(- (cadr IP) 48)(caddr IP)) VV 46.9325)
		   (polar IP VV 46.9325))
	      IP (list (car IP)(- (cadr IP) HOJ)(caddr IP)))
	(setq IP INS-P)))
    (setq PP IP
          FLA-LIS (get-typli TGA2-LIS))
    (cond ((and (member NR '(2 3 4))(> N 0)(<= N (- (* (1+ A-Y) A-X) A-X))
                (memb FLA-LIS U-FLA-BTW))
	    (if (eq (substr TYP 1 1) "_")
	      (setq SS-F (v-ekw-bot- MIR SS-F IP D-Y))
              (setq SS-F (v-ekw-bot MIR SS-F IP D-Y))))
          ((and (eq N 0)
                (not (member TYP U-FLA-NON)))
             (cond ((or (memb FLA-LIS U-FLA-FLS)
                        (memb FLA-LIS U-FLA-FLL))
		     (if (member (substr STR 1 1) U-SIZ-LET)
                       (setq SS-F (v-eds-edl-bot MIR SS-F IP))
                       (setq SS-F (v-eds-edl-bot- MIR SS-F IP)) ))
		   ((memb FLA-LIS U-FLA-EDN)
		     (if (member (substr STR 1 1) U-SIZ-LET)
                       (setq SS-F (v-edn-bot MIR SS-F IP))
                       (setq SS-F (v-edn-bot- MIR SS-F IP)) ))
		   ((memb FLA-LIS U-FLA-EDE)
		     (if (member (substr STR 1 1) U-SIZ-LET)
                       (setq SS-F (v-ede-bot MIR SS-F IP))
                       (setq SS-F (v-ede-bot- MIR SS-F IP)) ))
		   ((memb FLA-LIS U-FLA-EDB)
		     (if (member (substr STR 1 1) U-SIZ-LET)
                       (setq SS-F (v-edb-bot MIR SS-F IP))
                       (setq SS-F (v-edb-bot- MIR SS-F IP)) ))
		   ((memb FLA-LIS U-FLA-EDP)
		     (if (member (substr STR 1 1) U-SIZ-LET)
                       (setq SS-F (v-edp-bot MIR SS-F IP))
                       (setq SS-F (v-edp-bot- MIR SS-F IP)) ))
                   ((or (memb FLA-LIS U-FLA-PRH)
			(memb FLA-LIS U-FLA-PRW))
                     (if (member (substr STR 1 1) U-SIZ-LET)
                       (setq SS-F (v-edh-bot MIR SS-F IP))
                       (setq SS-F (v-edh-bot- MIR SS-F IP)) ))
                   ((memb FLA-LIS U-FLA-PRZ)
                     (if (member (substr STR 1 1) U-SIZ-LET)
                       (setq SS-F (v-edz-bot MIR SS-F IP))
                       (setq SS-F (v-edz-bot- MIR SS-F IP)) ))
		   ) ))
    (cond ((and (eq N 0)
		(or (member "BFX" FLA-LIS)(member "BDX" FLA-LIS))
		(not (member TYP '("CLI" "VFE" "VFA" "VFB" "VIU" "VEA" "VEB" "VEC"))))
             (setq SS-F (v-bfx-bot MIR SS-F IP)))
          ((and (member NR '(2 3 4))(> N 0)
               (or (member "BFX" FLA-LIS)(member "BDX" FLA-LIS))
               (<= N (- (* (1+ A-Y) A-X) A-X)))
             (if (not (member TYP '("CLI" "VFE" "VFA" "VFB" "VIU")))
               (setq SS-F (v-bfx-btw MIR SS-F IP D-Y t))
               (setq SS-F (v-bfx-btw MIR SS-F IP D-Y nil)) )) )
    (setq SS-F (if (member TYP U-RED-BOT)
                 (if (member TYP '("_VFE" "_VFA" "_VFB"))
                   (red-mark SS-F
                     (list (- (car IP)(* MIR (+ 130 -12)))(- (cadr IP) 30)(caddr IP)))
                   (red-mark SS-F IP))
                 SS-F))
      (if (member TYP '("GVA" "GVO" "GVT" "VLT"
                        "_GVA" "_GVO" "_GVT" "_VLT"))
        (progn
          (setq SS-F (v-kla TYP MIR SS-F IP HOJ GT)
		PP   IP
		IP   (list (car PP)(+ (cadr PP) HOJ)(caddr PP))
                TOP- IP))
        (progn
	  (if (member TYP '("_FRS" "_eFRS" "_FRS_" "_eFRS_"
			    "FRS" "eFRS" "FRS_" "eFRS_"))
	    (setq SS-F (frs-xnv TYP MIR SS-F IP STR)
		  IP   (if (member TYP '("FRS" "eFRS" "FRS_" "eFRS_"))
			 (list (- (car IP)(* MIR 157))(+ (cadr IP) 213)(caddr IP))
			 (list (- (car IP)(* MIR 132.85))(+ (cadr IP) 206.5)(caddr IP)) )
		  PP   IP) )
          (setq ;SS-F (if (member TYP U-RED-BOT)
                ;       (if (member TYP '("_VFE" "_VFA" "_VFB"))
                ;         (red-mark SS-F
                ;           (list (- (car IP)(* MIR (+ 130 -12)))(- (cadr IP) 30)(caddr IP)))
                ;         (red-mark SS-F IP))
                ;       SS-F)
                SS-F (v-frame-bot TYP MIR SS-F IP)
                SS-F (v-frame-bot-metal TYP MIR SS-F IP)
                SS-F (cond ;((and (eq NR 8)(eq N 0))
                           ;  (setq PB (list (+ (car IP)(* MIR 77))(+ (cadr IP) 56.3259)(caddr IP))
                           ;        RT (rot-lin (list (+ (car INS-P) (* MIR 78.3250))(cadr INS-P))
                           ;                    (list (+ (car INS-P) (* MIR 78.3250))(1+ (cadr INS-P)))
                           ;                    INS-P (dtr (- 90 DCH)) MIR)
                           ;        PT (inters (car RT)(cadr RT)
                           ;                   PB (list (car PB)(1+ (cadr PB)))
                           ;                   nil)
                           ;        PPB PT)
                           ;  (v-frame-li SS-F PB PT))
                           ;((eq NR 8)
                           ;  (setq PT (list (+ (car IP)(* MIR 78.3250))(+ HOJ -38.4576 (cadr IP))(caddr IP))
                           ;        RT (rot-lin PPB (list (car PPB)(1+ (cadr PPB)))
                           ;                    INS-P (* -1 (dtr (- 90 DCH))) MIR)
                           ;        PB   (inters (car RT)(cadr RT)
                           ;                     PT (list (car PT)(1+ (cadr PT)))
                           ;                     nil))
                           ;  (v-frame-li SS-F PB PT))
                           ((and (eq NR 8)(eq N 0))
                             (setq PB (list (+ (car IP)(* MIR 46.7))(+ (cadr IP) 44)(caddr IP))
                                   RT (rot-lin (list (+ (car INS-P) (* MIR 46.70))(cadr INS-P))
                                               (list (+ (car INS-P) (* MIR 46.70))(1+ (cadr INS-P)))
                                               INS-P (dtr (- 90 DCH)) MIR)
                                   PT (inters (car RT)(cadr RT)
                                              PB (list (car PB)(1+ (cadr PB)))
                                              nil)
                                   PPB PT)
                             (v-frame-li SS-F PB PT))
                           ((eq NR 8)
                             (setq PT (list (+ (car IP)(* MIR 46.70))(+ HOJ -38.4576 (cadr IP))(caddr IP))
                                   RT (rot-lin PPB (list (car PPB)(1+ (cadr PPB)))
                                               INS-P (* -1 (dtr (- 90 DCH))) MIR)
                                   PB   (inters (car RT)(cadr RT)
                                                PT (list (car PT)(1+ (cadr PT)))
                                                nil))
                             (v-frame-li SS-F PB PT))
                           (t (v-frame-lin TYP MIR SS-F IP HOJ)))
	           SS-F (cond ((and (member NR '(6))(> N 0))
				(v-extra-metal-6-bot MIR SS-F IP))
			      (t SS-F))
                         SS-S (v-sash-bot TYP MIR SS-S IP)
                         SS-S (v-sash-bot-metal TYP MIR SS-S IP GT)
                         SS-S (if (eq TYP "CLI") SS-S (v-sash-lin TYP MIR SS-S IP HOJ))
	           SS-S (cond ((and (member NR '(5))(> N 0))
			         (v-extra-metal-5-bot MIR SS-S IP))
			      (t SS-S))
                         SS-S (v-sash-glass TYP MIR SS-S IP HOJ GT)
                         IP   (list (car PP)(+ (cadr PP) HOJ)(caddr PP))
                         TOP- IP
                         SS-F (v-frame-top TYP MIR SS-F IP)
                         SS-F (v-frame-top-metal TYP MIR SS-F IP)
	           SS-S (v-sash-top TYP MIR SS-S IP)
                         SS-S (v-sash-top-metal TYP MIR SS-S IP GT)
                         SS-V (v-vent TYP MIR SS-V IP)
                         IP   (if (member TYP '("_GEL"))
                                (list (+ (car IP) (* MIR 29.325))(cadr IP)(caddr IP))
                                IP)
                        ; SS-F (if (member TYP U-RED-TOP)
                         ;       (red-mark SS-F IP)
                         ;       SS-F)
		) ))
    (setq SS-F (if (member TYP U-RED-TOP)
                 (red-mark SS-F IP)
                 SS-F))
    (if (and (eq N (- (* (1+ A-Y) A-X) A-X))
             (or (memb FLA-LIS U-FLA-FLS)
                 (memb FLA-LIS U-FLA-EDN)
                 (memb FLA-LIS U-FLA-EDE)
                 (memb FLA-LIS U-FLA-EDB)
                 (memb FLA-LIS U-FLA-EDP)
                 (memb FLA-LIS U-FLA-FLL)
		 (memb FLA-LIS U-FLA-PRH)
		 (memb FLA-LIS U-FLA-PRW)
                 (memb FLA-LIS U-FLA-PRZ) ))
      (cond ((member TYP '("GID" "GIR"))
	     (setq SS-F (v-gid-fla-top MIR SS-F IP)))
	    ((memb FLA-LIS U-FLA-EDN)
	     (setq SS-F (v-edn-top MIR SS-F IP)))
	    ((memb FLA-LIS U-FLA-EDE)
	     (setq SS-F (v-ede-top MIR SS-F IP)))
	    ((memb FLA-LIS U-FLA-EDB)
	     (setq SS-F (v-edb-top MIR SS-F IP)))
	    ((memb FLA-LIS U-FLA-EDP)
	     (setq SS-F (v-edp-top MIR SS-F IP)))
            (t
	     (if (member (substr STR 1 1) U-SIZ-LET)
	       (setq SS-F (v-eds-edl-edh-top MIR SS-F IP))
	       (if (or (memb FLA-LIS U-FLA-PRH)
		       (memb FLA-LIS U-FLA-PRW)
		       (memb FLA-LIS U-FLA-PRZ))
		 (setq SS-F (v-edh-top- MIR SS-F IP))
		 (setq SS-F (v-eds-edl-edh-top- MIR SS-F IP)) )) )))
    (if (and (or (member "BFX" FLA-LIS)(member "BDX" FLA-LIS))
             (not (member TYP '("CLI" "VFE" "VFA" "VFB" "VIU")))
             (eq N (- (* (1+ A-Y) A-X) A-X)))
      (setq SS-F (v-bfx-top MIR SS-F IP)))
    
    (if paucheck (progn (princ "\nget-typlis ?")(princ (list n a-x a-y))))
    (if (eq NR 7);(and (eq NR 7)(member N '(1 3 5 7)))
      (setq LIN-LIS (append (get-typlis 0 A-X A-Y TGA3-LIS)
			    (get-typlis 1 A-X A-Y TGA3-LIS)))
      (setq LIN-LIS (get-typlis N A-X A-Y TGA3-LIS)) )
    
    (if (and (member "BDX" FLA-LIS)
             (not (member TYP '("CLI" "VFE" "VFA" "VFB" "VIU")))
             (not (and (member NR '(5 6 7))(> N 0))))
      (setq SS-F (v-bdx-bot MIR SS-F PP
                   (if (memb '("LSD" "LSC" "LSB" "LLD" "LLC" "LLB" "LST") LIN-LIS) DCH nil) )))
    (if (and (member "BDX" FLA-LIS)
             (not (member TYP '("CLI" "VFE" "VFA" "VFB" "VIU")))
             (not (and (member NR '(5 6 7))(eq N 0))))
      (setq SS-F (v-bdx-top MIR SS-F IP
                   (if (memb '("LSD" "LSC" "LSB" "LLD" "LLC" "LLB" "LST") LIN-LIS) DCH nil) )))
    (setq LGI nil)
    (if paucheck (progn (princ "\nLGI member ?")(princ LIN-LIS)))
    (if (member "LGI" LIN-LIS)
      (progn
	(setq LGI t
	      LLX 60
              PL (if (member TYP '("_GEL"))
                   (list (+ (car PP) (* MIR 29.325))(cadr PP)(caddr PP))
                   PP)
              PB (list (+ (* MIR 46.7)(car PL))
	               (+ (cadr PL) 37.3)(caddr PL))
	      PT (list (+ (* MIR 46.7)(car PL))
		       (+ (cadr PL) HOJ -38.4993)(caddr PL)) )
        (if (or (member NR '(0 2 3 4))
  	        (and (member NR '(5 7))(eq N 0)))
          (setq SS-F (v-lgi MIR SS-F PB nil))
          (setq PB (list (car PB)(cadr PL)(caddr PB))) )
        (if (or (member NR '(0 2 3 4))
	        (and (member NR '(5 6 7 8))(eq N (- (* (1+ A-Y) A-X) A-X))))
          (setq SS-F (v-lgi MIR SS-F PT t))
          (setq PT (list (car PT)(+ (cadr PT) HOJ)(caddr PT))) )
        (if (member NR '(6 8))
          (if (eq N 0)
            (setq DYY  (if (eq NR 6) 108.70 138.0250)
                  DY   (if (eq NR 6) 26 56.3259)
                  DXX  (cond ((and (eq NR 6) (member TYP '("VIU"))) 34.7)
			     ((eq NR 6) 0 )
			     (t         77))
                  PBB  (list (+ (car PP) (* MIR DXX))(+ (cadr PP) DY)(caddr PP))
                  PB   (list (+ (car PP) (* MIR (+ 62 DXX)))(+ (cadr PP) DY)(caddr PP))
                  SS-F (v-lgi-li SS-F PBB PB)
                  RT   (rot-lin (list (+ (car INS-P) (* MIR DYY))(cadr INS-P))
                                (list (+ (car INS-P) (* MIR DYY))(1+ (cadr INS-P)))
                                INS-P (dtr (- 90 DCH)) MIR)
                  PT   (list (car PB)(cadr PT)(caddr PT))
                  PT   (inters (car RT)(cadr RT)
                               PT (list (car PT)(1+ (cadr PT)))
                               nil)
                  PBB  PT)
            (setq RT   (rot-lin PBB (list (car PBB)(1+ (cadr PBB)))
                                INS-P (* -1 (dtr (- 90 DCH))) MIR)
                  PB   (list (+ (car PB) (* MIR 62))(cadr PB)(caddr PB))
                  PB   (inters (car RT)(cadr RT)
                               PB (list (car PB)(1+ (cadr PB)))
                               nil)
                  PB   (list (+ (car PB) (* MIR -62))(cadr PB)(caddr PB)) ) ))
        (if (and (member NR '(6 8))(eq N 0))
          (setq SS-F (v-lgi-li SS-F PB PT))
          (setq SS-F (v-lgi-lin SS-F PB PT)) ) ))
      (if (member TYP '("_FRS" "_eFRS" "_FRS_" "_eFRS_")) ; LAX
	(setq SS-F (if (eq (substr STR 2 2) "04")
		     (lax-top MIR SS-F (list (car IP)(+ (cadr IP) 8)(caddr IP)) LLL)
		     (lax-top MIR SS-F IP LLL))
	      SS-F (if (eq (substr STR 2 2) "04")
		     (lax-bot MIR SS-F
			    (list (car IP)(- (cadr IP) HOJ 8)(caddr IP)) LLL)
		     (lax-bot MIR SS-F
			    (list (car IP)(- (cadr IP) HOJ)(caddr IP)) LLL)) ))
      (if (memb '("LSD" "LSC" "LSB" "LLD" "LLC" "LLB" "LVI" "LST") LIN-LIS)
        (progn
  	  (setq PT   (list (+ (* MIR (+ LLX 46.7 -12))(car PP))
		         (+ (cadr PP) HOJ -38.4993 8.5)(caddr PP))
                PB   (list (+ (* MIR (+ LLX 46.7 -12))(car PP))
	                 (+ (cadr PP) 37.3 -8.5)(caddr PP))
                LL   (- LLL 33.7))
	  (if LGI (setq LL (- LL 60)))
          (if (not (and (eq N 0) (member NR '(5 6 7))))
	    (setq SS-P (v-ls-tt MIR SS-F PT LL DCH)
                  SS-F (car SS-P)
                  PT   (cadr SS-P)
                  V    (cond ((< DCH 30) 30)
                             ((> DCH 60) 60)
                             (t DCH))
                  PT   (list (+ (* MIR 12)(car PT))
                             (- (cadr PT) (get-tri-a nil (dtr V) 3.0 nil))
                                  (caddr PT))
                  SS-F (v-ls-kt MIR SS-F PT) )
            (setq PT   (if (member NR '(6))
                         (polar PT (if (eq MIR -1) pi 0) (+ 11 -33.7 -130 (cadr (cadr AFS))))
                         (polar PT (if (eq MIR -1) pi 0) (+ 11 LL)))
                  PT   (polar PT (/ pi 2.0) 34.8)
                  ) )
          (if (not (or (eq NR 6)(and (> N 0) (member NR '(5 6 7)))))
            (setq SS-P (v-ls-bb MIR SS-F PB LL DCH LIN-LIS)
                  SS-F (car SS-P)
                  PB   (cadr SS-P)
                  SPL  (list (entlast)(get-point-lis (entlast))) ; til hylde beregning
                  PB   (list (+ (* MIR 12)(car PB))(+ 12.5 5.5 (cadr PB))(caddr PB)) )
            (setq PB   (if (and (eq N 0) (member NR '(6)))
                         (polar PB (if (eq MIR -1) pi 0) (+ 11 -33.7 -130 (cadr (cadr AFS))))
                         (polar PB (if (eq MIR -1) pi 0) (+ 11 LL)))
                  PB   (polar PB (/ pi -2.0) 34.8) ) )
	  (setq   PBB   (list (+ (* MIR 3)(car PB)) (cadr PB) (caddr PB))
		  PTT   (list (+ (* MIR 3)(car PT)) (cadr PT) (caddr PT)))
          (cond ((memb '("LFI" "LEI" "LXI") LIN-LIS)
                  (setq V1   (cond ((< DCH 30) 60)
                                   ((> DCH 60) 30)
                                   (t (+ 45 (- 45 DCH))))
                        V1   (if (eq MIR -1) (- 180 V1) V1)
                        PH   (list (+ (* MIR (+ LLX 46.7))(car PP))
	                           (+ (cadr PP) 29)(caddr PP))
	                           ;(+ (cadr PP) 37.3)(caddr PP))
                        PH   ;(if (< DCH 45)
                               ;(inters PH (polar PH (dtr V1) 10)
                                          ;(nth 0 (cadr SPL))(nth 1 (cadr SPL)) nil)
                               (inters PH (polar PH (dtr V1) 10)
                                          (nth 2 (cadr SPL))(nth 3 (cadr SPL)) nil);)
                        PH   (if (memb '("LFI") LIN-LIS)
				   (polar PH (dtr (- V1 (* MIR 90))) 50.0)
				   (polar PH (dtr (- V1 (* MIR 90)))(caddr (cadr AFS))))
                        SS-F (cond ((memb '("LFI") LIN-LIS)
                                      (v-lfi MIR SS-F PH DCH (car (cadr AFS))))
                                   ((memb '("LEI") LIN-LIS)
                                     (if (memb '("LEX") LIN-LIS)
                                        (v-lex MIR SS-F PH DCH (cadr (cadr AFS)) SPL)
                                        (v-lei MIR SS-F PH DCH (cadr (cadr AFS)) SPL)))
                                   ((memb '("LXI") LIN-LIS)
                                      (v-lxi MIR SS-F PH DCH (cadr (cadr AFS)) SPL))
                                   (t SS-F))
                        PH   (polar PH (dtr (if (eq MIR 1)(- 90 DCH)(+ 90 DCH)))
                                    (+ 16 (cadr (cadr AFS))))
                        PHL  PH
                        PH   (polar PH (dtr (if (eq MIR 1)(* -1 DCH)(+ 180 DCH)))
                                    (if (memb '("LEI") LIN-LIS) (+ 6 19)(+ 6 19 28)) )
                        PHH  (inters PH (polar PH (dtr (if (eq MIR 1)(- 180 DCH) DCH)) 10)
                                     PBB PTT nil) ) ) )
         (setq SS-F (cond ((memb '("LEX") LIN-LIS)
			    SS-F)
		          ((memb '("LEI" "LXI") LIN-LIS)
                             SS-F ;(v-ls-kb MIR SS-F PH (dtr (* MIR -1 (- DCH 90))))
			   )
                          ((and (eq N 0)(eq NR 6))
			     SS-F
                             ;(v-ls-kb MIR SS-F
                             ;  (polar (polar PB (/ pi 2.0) 6)(if (eq MIR -1) pi 0) 11) nil)
			   )
                          ((not (and (> N 0) (member NR '(5 6 7))))
                             ;(setq V  (cond ((< DCH 30) 30)
                             ;               ((> DCH 60) 60)
                             ;               (t DCH))
                             ;      PB (list (car PB)
                             ;               (+ (cadr PB) (get-tri-a (dtr V) nil 3.0 nil)
                             ;                  (cond ((> DCH 45) 2.8)
                             ;                        ((<= DCH 45) -3.0)
                             ;                        (t 0)))
                             ;               (caddr PB)))
                             (v-ls-kb MIR SS-F PB nil))
                          (t SS-F))
                SS-F (if (memb '("LEI" "LXI") LIN-LIS)
                       (v-li-lin MIR SS-F PP PHL PHH PTT DCH LIN-LIS (cadr (cadr AFS)))
                       (if (eq NR 6);LVI
                         (if (eq N 0)
                           (progn
                             (setq IPL (list PBB PTT)
                                   PBB  (list (car PBB)(+ (cadr PBB) 32)(caddr PBB)))
                             (v-lvi MIR SS-F PBB (cadr (cadr AFS)) ) )
                           (progn
                             (v-lvi-lin MIR SS-F PP PBB PTT IPL DCH LIN-LIS (cadr (cadr AFS)))))
                         (v-ls-lin MIR SS-F PBB PTT) ) ))
    ))
    
    (if (eq (substr TYP 1 1) "_")
      (setq PP (list (- (car PP) (* MIR 27))(cadr PP)(caddr PP))))

    (setq DSP-LIS (get-typlis N A-X A-Y TGA4-LIS)
          DPT PP
          DPB PP
          S-S (cond ((memb '("FHL" "FML" "FHU") DSP-LIS)  
                       (v-fhl MIR SS-S PP HOJ))
                    (t SS-S))
	  S-S (cond ((memb '("FYL" "FKL" "FPL") DSP-LIS)
                       (v-fyl MIR SS-S PP HOJ))
                    (t SS-S))
	  S-S (cond ((memb '("PAL" "PBL" "PML" "PAU" "PBU" "PMU") DSP-LIS)
                       (v-pal MIR SS-S PP HOJ))
                    (t SS-S))
	  S-S (cond ((memb '("RHL" "RLL" "RML" "RNL" "RPL" "RFU" "RFL" "RGL" "RLG" "RLT") DSP-LIS)
                       (v-rhl MIR SS-S PP HOJ))
                    (t SS-S))
	  S-S (cond ((memb '("DKL" "DGL" "DML" "DKU") DSP-LIS)
                       (v-dkl MIR SS-S PP HOJ))
                    (t SS-S))
          S-S (cond ((memb '("MHL" "MAL") DSP-LIS)
                       (v-mhl MIR SS-S PP HOJ))
	            (t SS-S))
          S-F (cond ((memb '("SCL" "SML" "SSL") DSP-LIS)
                       (v-scl MIR SS-F PP HOJ))
	            ((and (memb '("SMG") DSP-LIS) (member TYP '("GIL" "GIU")))
                       (v-scl MIR SS-F PP (- HOJ 273)))
	            ((and (memb '("SMG") DSP-LIS) (not (member TYP '("GIL" "GIU"))))
                       (v-smg-t MIR SS-F PP HOJ))
	            ((member "MML" DSP-LIS)
	               (v-mml MIR SS-F PP HOJ))
	            ((memb '("MIE") DSP-LIS)
                       (v-mie MIR SS-F PP HOJ))
                    (t SS-F)) )
    (if (member "ZIL" DSP-LIS)
      (setq S-F (v-xxx MIR SS-F PP HOJ)))
    (if (member "ZGL" DSP-LIS)
      (setq S-F (v-xxx MIR SS-F PP HOJ)))
    (if (member "SFL" DSP-LIS)
      (setq S-F (v-xxx MIR SS-F PP HOJ)))
    (if (member "MIE" DSP-LIS)
      (setq S-F (v-xxx MIR SS-F PP HOJ)))
    
    (if (eq (substr TYP 1 1) "_")
      (setq PP (list (+ (car PP) (* MIR 27))(cadr PP)(caddr PP))))

    (setq SS1 (do-block-2 (itoa N) TYP MIR SS1 PP SS-F SS-S SS-V))
    (if (and USER-ROT (member NR '(6 8))(> N 0))
      (command "_rotate" SS1 "" PP (* MIR (dtr (- DCH 90)))))
    (setq SS (ss-add SS1 SS)
          N  (+ N A-X)
          IP (list (car PP)(+ (cadr PP) HOJ D-Y)(caddr PP)) ))
  (if (eq USER-IP "top")
    (progn
      (command "_.point" TOP-)
      (if (and USER-ROT (member NR '(6 8))(> N 0))
        (command "_rotate" (entlast) "" PP (* MIR (dtr (- DCH 90)))))
      (setq SS (ssadd (entlast) SS)) ))
  (cond ((and USER-ROT (member NR '(0 1 3 2 4 5 7 9 10 12)))
          (command "_rotate" SS "" INS-P (* MIR (dtr (- DCH 90)))))
        ;((and USER-ROT (member NR '(10 12)))
        ;  (command "_rotate" SS "" INS-P (* MIR (dtr DCH))))
        ((and USER-ROT (member NR '(11)))
          (command "_rotate" SS "" INS-P (* MIR (dtr (- DCH 90 -18.5))))))
        
  SS)
;============================================================================
;============================================================================
(defun ins-2d-h ( NR INS-P DCH AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS
                / LLL LLX D-X D-Y A-X A-Y N SSS SS IP PP
                  SS1 SS-F SS-S SS-V TYP STR PCO GT BRE HOJ
                  FLA-LIS LIN-LIS DSP-LIS)
  (if paucheck (princ "\nins-2d-h"))
  (if (not get-2d-h)(load (strcat VELUX-DIR "velux_2d.lsp")))
  (setq LLL  (car (cadr AFS))
        LLX  0
	D-X  (car (car AFS))
	D-Y  (cadr (car AFS))
	A-X  (caddr (car AFS))
	A-Y  (cadddr (car AFS))
	N    (if (member NR '(2 3 4 5 7))
	       (- (* (1+ A-Y) A-X) A-X)
	       0)
	SSS  (ssadd)
	SS   (ssadd))
  (while (< N (* (1+ A-Y) A-X))
    (if (and (member NR '(6 8))(eq N 0))
      (setq IP (list (car INS-P)(- (cadr INS-P) (+ 300 LLL))(caddr INS-P)))
      (setq IP INS-P))
    (repeat A-X
      (get-data-2 (nth N TGA1-LIS) (nth (1+ N) TGA1-LIS))
      (setq FLA-LIS (get-typli TGA2-LIS))
      (cond ((and (or (eq N 0) (eq (gcd N A-X) A-X))
                  (not (and (member NR '(6 8))(< N A-X))))
               (cond ((or (memb FLA-LIS U-FLA-FLS)
                          (memb FLA-LIS U-FLA-PRH)
			  (memb FLA-LIS U-FLA-PRW)
			  (memb FLA-LIS U-FLA-PRZ)
			  )
		        (if (member (substr STR 1 1) U-SIZ-LET)
                          (setq SS-F (h-edh-eds -1 SS-F IP))
                          (setq SS-F (h-edh-eds -1 SS-F IP)) ))
		     ((memb FLA-LIS U-FLA-EDE)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                        (setq SS-F (h-ede -1 SS-F IP))
                        (setq SS-F (h-ede -1 SS-F IP)) ))
		     ((memb FLA-LIS U-FLA-EDN)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                        (setq SS-F (h-edn -1 SS-F IP))
                        (setq SS-F (h-edn -1 SS-F IP)) ))
		     ((memb FLA-LIS U-FLA-EDP)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                        (setq SS-F (h-edp -1 SS-F IP))
                        (setq SS-F (h-edp -1 SS-F IP)) ))
		     ((memb FLA-LIS U-FLA-EDB)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                        (setq SS-F (h-edb -1 SS-F IP))
                        (setq SS-F (h-edb -1 SS-F IP)) ))
                     ((memb FLA-LIS U-FLA-FLL)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                        (setq SS-F (h-edl -1 SS-F IP))
                        (setq SS-F (h-edl -1 SS-F IP)) )) ) )
            ((and (member NR '(3 4 7 8))(> N 0)
                  (> D-X 18)
                  (not (and (member NR '(6 8))(< N A-X)))
		  (not (eq (gcd N A-X) A-X))
                  (memb FLA-LIS U-FLA-BTW))
	       (if (memb FLA-LIS U-FLA-EDN)
		 (setq SS-F (h-etn SS-F IP D-X))
	         (setq SS-F (h-ekw SS-F IP D-X))))
            ((and (member NR '(2 8))(> N 0)
                  (<= D-X 18)
		  (not (eq (gcd N A-X) A-X))
                  (not (eq (car FLA-LIS) "")))
	      (setq SS-F (h-eby-metal SS-F IP))
	     )
            ((and (member NR '(6 8))(> N 0)
		  (not (eq (gcd N A-X) A-X))
                  (memb FLA-LIS U-FLA-BTW))
              (setq SS-F (h-eew SS-F IP D-X))) )
      (cond ((and (member NR '(2 8))(> N 0)
                  (<= D-X 18)
		  (not (eq (gcd N A-X) A-X))
                  (eq "EBY" (get-typ (car (reverse TGA1-LIS)))))
	     ;(if (eq NR 8)
	       ;(if (> N A-X)
	         ;(setq SS-F (h-eby SS-F (list (car IP)(+ 24 (cadr IP))(caddr IP))))
	         ;(setq SS-F (h-eby SS-F (list (car IP)(+ 54 (cadr IP))(caddr IP)))) )
	       (if (eq "W35" (get-siz (car (reverse TGA1-LIS))))
                 (setq SS-F (h-eby-big SS-F IP))
                 (setq SS-F (h-eby SS-F IP))) ;)
	     ))
      (cond ((and (or (member "BFX" FLA-LIS)(member "BDX" FLA-LIS))
                  (not (eq TYP "CLI"))
                  (not (and (member NR '(6 8))(< N A-X))))
               (if (and (member NR '(2 3 4 7 8))(> N 0)
		        (not (eq (gcd N A-X) A-X)))
		 (if (> D-X 18)
                   (setq SS-F (h-bfx-btw SS-F IP D-X))
		   SS-F)
                 (setq SS-F (h-bfx -1 SS-F IP)) ) ))
      (cond ((and (member "BDX" FLA-LIS)
                  (not (eq TYP "CLI"))
                  (not (and (member NR '(6 8))(< N A-X)))
		  (not (and (member NR '(2))(> N 0)
			    (not (eq (gcd N A-X) A-X))
			    (<= D-X 18))))
               (setq SS-F (h-bdx -1 SS-F IP)) ))
      
      (setq IP (list (- (car IP) BRE)(cadr IP)(caddr IP))
            PP IP
	    SS-F (red-mark SS-F IP))
        
      (if (member TYP '("GVA" "GVO" "GVT" "VLT"
                        "_GVA" "_GVO" "_GVT" "_VLT"))
        (progn
	  (setq ;IP (list (+ (car IP) BRE)(cadr IP)(caddr IP))
                SS-F (h-kla TYP SS-F IP BRE GT)
		PP   IP
		IP   (list (+ (car PP) BRE)(cadr PP)(caddr PP)) ))
        (progn
	  (if (member TYP '("_FRS" "_eFRS" "_FRS_" "_eFRS_"
			    "FRS" "eFRS" "FRS_" "eFRS_"))
	    (setq SS-F (h-frs -1 SS-F (list (- (car IP) 194 -3)
					    (cadr INS-P) (caddr IP)))
		  SS-F (h-frs 1 SS-F (list (+ (car IP) BRE -3)
					    (cadr INS-P) (caddr IP)))
		  IP   (list (+ -97.0000 (car IP))
			     (+ 197.2751 26 (cadr IP))(caddr IP))
		  PP   IP))
          (setq ;SS-F (red-mark SS-F IP)
                SS-F (h-frame TYP 1 SS-F IP)
                SS-F (cond ((memb FLA-LIS U-FLA-EDN)
			     (h-edn-x 1 SS-F IP))
			   ((and (member NR '(2 8))(<= D-X 18)
				 (or (eq N 0)
				     (and (>= N A-X)(< N (- (* 2 A-X) 1))))
			         ;(not (eq (car FLA-LIS) ""))
				 )
                              SS-F)
			   ((and (member NR '(8))(< N (1- A-X)))
                              SS-F)
			   (t
                              (h-frame-metal TYP 1 SS-F IP) ))
                SS-F (if (eq TYP "CLI")
                       (h-cli 1 SS-F IP)
                       SS-F)
                SS-F (h-frame-lin TYP 1 SS-F IP BRE)
                SS-S (h-sash TYP 1 SS-S IP)
                SS-S (h-sash-metal TYP 1 SS-S IP GT)
                SS-S (h-sash-lin TYP 1 SS-S IP BRE)
	        SS-S (cond ((and (member NR '(7))(eq TYP "GDL-t"))
  				          (h-extra-metal-7 1 SS-S IP))
				       (t SS-S))
                SS-S (h-sash-glass TYP 1 SS-S IP BRE GT)
                IP   (list (+ (car PP) BRE)(cadr PP)(caddr PP))
                ;SS-F (red-mark SS-F IP)
                SS-F (h-frame TYP -1 SS-F IP)
                SS-F (cond ((memb FLA-LIS U-FLA-EDN)
			     (h-edn-x -1 SS-F IP))
			   ((and (member NR '(2 8))(<= D-X 18)
				 (or (and (> N 0) (< N A-X))
				     (> N A-X))
			         ;(not (eq (car FLA-LIS) ""))
				 )
                              SS-F)
			   ((and (member NR '(8))
				 (> N 0)(< N A-X))
                              SS-F)
			   (t
                              (h-frame-metal TYP -1 SS-F IP) ))
                SS-F (if (eq TYP "CLI")
                       (h-cli -1 SS-F IP)
                       SS-F)
	        SS-S (h-sash TYP -1 SS-S IP)
                SS-S (h-sash-metal TYP -1 SS-S IP GT)
	        SS-S (cond ((and (member NR '(7))(eq TYP "GDL-t"))
				          (h-extra-metal-7 -1 SS-S IP))
				       (t SS-S)) )
	  ))
      (setq SS-F (red-mark SS-F IP)
            IP (list (- (car IP) BRE)(cadr IP)(caddr IP)))
      
      (cond ((and (eq (gcd (1+ N) A-X) A-X)
                  (not (and (member NR '(6 8))(< N A-X))))
               (cond ((or (memb FLA-LIS U-FLA-FLS)
                          (memb FLA-LIS U-FLA-PRH)
                          (memb FLA-LIS U-FLA-PRW)
                          (memb FLA-LIS U-FLA-PRZ)
			  )
		        (setq SS-F (h-edh-eds 1 SS-F IP)) )
		     ((memb FLA-LIS U-FLA-EDE)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                          (setq SS-F (h-ede 1 SS-F IP))
                          (setq SS-F (h-ede 1 SS-F IP)) ))
		     ((memb FLA-LIS U-FLA-EDN)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                          (setq SS-F (h-edn 1 SS-F IP))
                          (setq SS-F (h-edn 1 SS-F IP)) ))
		     ((memb FLA-LIS U-FLA-EDP)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                          (setq SS-F (h-edp 1 SS-F IP))
                          (setq SS-F (h-edp 1 SS-F IP)) ))
		     ((memb FLA-LIS U-FLA-EDB)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                          (setq SS-F (h-edb 1 SS-F IP))
                          (setq SS-F (h-edb 1 SS-F IP)) ))
                     ((memb FLA-LIS U-FLA-FLL)
		        (if (member (substr STR 1 1) U-SIZ-LET)
                          (setq SS-F (h-edl 1 SS-F IP))
                          (setq SS-F (h-edl 1 SS-F IP)) )) ) ))
      (cond ((and (eq (gcd (1+ N) A-X) A-X)
                  (or (member "BFX" FLA-LIS)(member "BDX" FLA-LIS))
                  (not (eq TYP "CLI"))
                  (not (and (member NR '(6 8))(< N A-X))) )
               (setq SS-F (h-bfx 1 SS-F IP)) ))
      (cond ((and (member "BDX" FLA-LIS)
                  (not (eq TYP "CLI"))
                  (not (and (member NR '(6 8))(< N A-X)))
		  (not (and (member NR '(2))(= N 0)
			    (<= D-X 18))))
               (setq SS-F (h-bdx 1 SS-F IP)) ))

      (if paucheck (progn (princ "\nget-typlis ?")(princ (list n a-x a-y))))
      (if (eq NR 7);(and (eq NR 7)(member N '(1 3 5 7)))
        (setq LIN-LIS (append (get-typlis 0 A-X A-Y TGA3-LIS)
			      (get-typlis 1 A-X A-Y TGA3-LIS)))
        (setq LIN-LIS (get-typlis N A-X A-Y TGA3-LIS)) )

      (setq LGI nil)
      (if paucheck (progn (princ "\nLGI member ?")(princ LIN-LIS)))
      (if (member "LGI" LIN-LIS)
        (setq LGI t
	      LLX  60
              DY   (cond ((member TYP '("VFE" "VFA" "VFB")) -36.7)
                         ((member TYP '("VIU")) 0)
                         ((member TYP '("_VEA" "_VEB" "_VEC")) -53.2)
                         ((member TYP '("_GEL")) -28.2)
                         (t 0))
	      PB   (list (+ 36.2763 (car PP))(- (cadr PP) 46.7 DY)(caddr PP))
	      PT   (list (+ -36.2763 BRE (car PP))(- (cadr PP) 46.7 DY)(caddr PP))
              SS-F (h-lgi 1 SS-F PB)
              SS-F (h-lgi -1 SS-F PT)
              SS-F (h-lgi-lin SS-F PB PT)))
      (if LGI (setq LLL (- LLL 60)))
      (if (or (memb '("LSD" "LSC" "LSB" "LLD" "LLC" "LLB" "LST") LIN-LIS)
	      (member TYP '("_FRS" "_eFRS" "_FRS_" "_eFRS_"))) ; LAX
        (setq DY   (cond ((member TYP '("VFE" "VFA" "VFB")) -36.7)
                         ((member TYP '("_VEA" "_VEB" "_VEC")) -53.2)
                         ((member TYP '("_GEL")) -28.2)
                         ((member TYP '("_FRS" "_eFRS" "_FRS_" "_eFRS_"
					"FRS" "eFRS" "FRS_" "eFRS_")) -28)
                         (t 0))
	      DX   (cond ((member TYP '("_FRS_" "_eFRS_"
					"FRS_" "eFRS_")) -7)
                         ((member TYP '("_FRS" "_eFRS"
					"FRS" "eFRS")) -2)
                         (t 0))
	      LLL  (cond ((member TYP '("_FRS" "_eFRS" "_FRS_" "_eFRS_"
					"FRS" "eFRS" "FRS_" "eFRS_")) (+ LLL 180 28 18))
                         (t LLL))
	      PB   (list (+ (car PP) 27 DX)(- (cadr PP) 10.4383 LLL LLX DY)(caddr PP))
	      PT   (list (+ (- (car PP) 27 DX) BRE)(- (cadr PP) 10.4383 LLL LLX DY)(caddr PP))
              SS-F (h-ls-k 1 SS-F PB)
              SS-F (h-ls-k -1 SS-F PT)
              SS-F (h-ls- 1 SS-F PB LLL)
              SS-F (h-ls- -1 SS-F PT LLL)
              SS-F (h-ls-lin SS-F PB PT)) )
      (setq DSP-LIS (get-typlis N A-X A-Y TGA4-LIS))
      (cond ((memb '("SCL" "SML" "SSL" "SMG") DSP-LIS)
               (setq SS-F (h-scl MIR SS-F PP BRE)) )
	    ((or (member "MML" DSP-LIS))
	       (setq SS-F (h-mml MIR SS-F PP BRE)) ))
      (setq SS1 (do-block-2 (itoa N) "" 1 SS1 PP SS-F SS-S SS-V))
      (if (member NR '(6 8))
	(progn
	  (setq SSS (ss-add SS1 SSS))
	  (cond ((eq N (1- A-X))
	           (do-bl-2 "bottom" (list (car INS-P)
					 (- (cadr INS-P) 300 LLL)
					 (caddr INS-P))
			  SSS 0)
                   (setq SS (ssadd (entlast) SS)
		         SSS (ssadd)) )
	        ((eq N (1- (* (1+ A-Y) A-X)))
	           (do-bl-2 "top" INS-P SSS 0)
                   (setq SS (ssadd (entlast) SS)
		         SSS (ssadd)) )) )
	(setq SS (ss-add SS1 SS)) )
      (setq N  (+ N 1))
      (if (eq N A-X)
	(setq IP PP)
        (setq IP (list (- (car PP) D-X)(cadr PP)(caddr PP)) )) ))
  SS)
;============================================================================
;============================================================================
(defun ins-2d-p ( E NR INS-P DCH AFS TGA1-LIS TGA2-LIS TGA3-LIS TGA4-LIS
                / D-X D-Y A-X A-Y N SS IP PP VV
                  SS1 SS-F SS-S SS-V TYP STR PCO GT BRE HOJ
                  DSP-LIS)
  (if paucheck (princ "\nins-2d-p"))
  (if (not get-2d-h)(load (strcat VELUX-DIR "velux_2d.lsp")))
  (setq D-X  (car (car AFS))
	D-Y  (cadr (car AFS))
	A-X  (caddr (car AFS))
	A-Y  (cadddr (car AFS))
        N    ;(if (and (not E) (member NR '(6 8)))
               ;A-X
               0;)
	SS   (ssadd)
        IP   INS-P)
  (repeat (1+ A-Y)
    (setq PP IP
          VV (cond ((and E (member NR '(6 8)) (eq N 0)) 1)
		   (t
		    (if E (sin (dtr DCH)) (cos (dtr DCH))) )))
    (repeat A-X
      (if (not (and (not E) (member NR '(6 8)) (< N A-X)))
        (progn
          (get-data-2 (nth N TGA1-LIS) (nth (1+ N) TGA1-LIS))
          (setq SS-F (cond ((member TYP '("GIR" "GID" "GIV" "GIW" "GIZ" "GIY"))
                              (p-win-fun TYP VV SS-F IP STR))
                           ((member TYP '("GVA" "GVO" "GVT" "VLT"
				     "_GVA" "_GVO" "_GVT" "_VLT"))
                              (p-win-kla TYP VV SS-F IP BRE HOJ))
                           ((member TYP '("_FRS" "_eFRS" "_FRS_" "_eFRS_"
					  "FRS" "eFRS" "FRS_" "eFRS_"))
                              (setq SS-F (p-win-frs E TYP VV SS-F IP BRE HOJ)
				    P1   (if E
	                                   (list (+(car IP)89.9486)
						 (+(cadr IP)322.7563)(caddr IP))
	                                   (list (+(car IP)89.9486)
						 (+(cadr IP)117.3846)(caddr IP)))
			            VV   (if E (sin (dtr 18.5)) (cos (dtr 18.5))))
			      (p-win TYP VV SS-F P1 BRE HOJ))
			   ((member TYP '("VIU"))
			      (setq HOJ (+ 50 HOJ))
			      (p-win TYP VV SS-F IP BRE HOJ))
                           (t (p-win TYP VV SS-F IP BRE HOJ)))
                DSP-LIS (get-typlis N A-X A-Y TGA4-LIS))
          (cond ((memb '("SCL" "SML" "SSL") DSP-LIS)
                   (setq SS-F (p-scl VV SS-F IP BRE HOJ)) )
		((and (memb '("SMG") DSP-LIS) (member TYP '("GIL" "GIU")))
		   (setq SS-F (p-scl VV SS-F IP BRE (- HOJ 273))) )
		((and (memb '("SMG") DSP-LIS) (not (member TYP '("GIL" "GIU"))))
                   (setq SS-F (p-smg-t VV SS-F IP BRE HOJ)) )
	        ((member "MML" DSP-LIS)
	           (setq SS-F (p-mml VV SS-F IP BRE HOJ)) ))
          (setq SS1 (do-block-2 (itoa N) TYP 1 SS1 IP SS-F SS-S SS-V)
                SS (ss-add SS1 SS)
                IP (list (+ (car IP) BRE D-X)(cadr IP)(caddr IP)) )) )
      (setq N (1+ N)))
    (if (and (eq (gcd N A-X) A-X)
             (not (and (not E) (member NR '(6 8)) (>= N A-X))) )
      (setq IP (list (car PP)(+ (cadr PP) (* VV (+ HOJ D-Y)))(caddr PP)) )
      (setq IP PP) ) )
  (if (eq USER-IP "top")
    (progn
      (command "_.point" IP)
      (setq SS (ssadd (entlast) SS)) ))
  SS)
;============================================================================
;*************************************************************************
;    
;*************************************************************************
;*************************************************************************
;    rotering og blokning
;*************************************************************************
;============================================================================
(defun do-bl-2 (BN I-P SS-B ROT / BNN)
  (if paucheck (princ "\ndo-bl-2"))
  (setq BNN (strcat BN (substr (rtos (getvar "date") 2 10) 1 7)
                   "-" (substr (rtos (getvar "date") 2 10) 9 9)))
  (while (tblsearch "BLOCK" BNN)
    (setq BNN (strcat BNN "-")))
  (command "_.block" BNN I-P SS-B ""
           "_.insert" BNN I-P 1 1 0)
  (if (or (eq BN "extra")
          (and (eq (substr BN 1 (1- (strlen BN))) "vent-") USER-ROT-VENT)
          (and (eq (substr BN 1 (1- (strlen BN))) "sash-") USER-ROT-SASH))
    (command "_rotate" (entlast) "" I-P (dtr ROT))) )
;============================================================================
;============================================================================
(defun do-block-2 ( NN TYP MIR SS IP SS-F SS-S SS-V
                  / IP-I IP-S R-S IP-V R-V)
  (if paucheck (princ "\ndo-block-2"))
  (setq IP-I IP
        IP-S (cond ((member TYP '("GHL" "dGHL" "GPL" "dGPL" "GPU" "dGPU"
				  "GTL" "GTU" "GDL-t" "cGPL" "GID"))
		    (list (+ (car IP) (* MIR -89.4464))
			  (+ (cadr IP) HOJ -23.64)
			  (caddr IP)))
		   ((member TYP '("GGL" "GGU"  "G62" "G64"
				  "sGGL" "eGGL" "bGGL" "cGGL" "eGGU" "bGGU" "GIV"))
		    (list (car IP)(+ (cadr IP)(/ HOJ 2.0))(caddr IP)))
		   ((member TYP '("VFE"))
		    (list (+ (car IP) (* MIR -15.9000))
			  (+ (cadr IP) 41.6)
			  (caddr IP)))
		   (t IP))
	R-S  (cond ((member TYP '("VFE"))        -15)
		   ((member TYP '("GHL" "dGHL"))        -30)
		   ((member TYP '("GPL" "GPU" "GID"
				  "cGPL" "dGPL" "dGPU"))       -45)
		   ((member TYP '("GDL-t"))      -45)
		   ;((member TYP '("GDL-b"))      45)
		   ((member TYP '("GXL"))        0)
		   ((member TYP '("GTL" "GTU"))        -70)
		   ((member TYP '("GGL" "GGU" "GIV"
				  "eGGU" "bGGU"
				  "cGGL" "sGGL" "eGGL" "bGGL"))-25)
		   ((member TYP '("G62" "G64"))   -25)
		   ((member TYP '("GIL"))          0)
		   (t                              0))
        IP-V (cond ((member TYP '("G62" "G64"))
		     (list (- (car IP) (* MIR -49.1))
		           (+ (cadr IP) HOJ -122)(caddr INS-P)) )
		   (t
		     (list (- (car IP) (* MIR 3))
		           (+ (cadr IP) HOJ -122)(caddr IP)) ))
	R-V  -55)
  (if paucheck (princ "\ndo-block"))
  (if (> (sslength SS-V) 0)
    (progn
      (do-bl-2 (strcat "vent-" NN) IP-V SS-V (* MIR R-V))
      (setq SS-S (ssadd (entlast) SS-S)) ))
  (if (> (sslength SS-S) 0)
    (progn
      (do-bl-2 (strcat "sash-" NN) IP-S SS-S (* MIR R-S))
      (setq SS (ssadd (entlast) SS)) ))
  (if (> (sslength SS-F) 0)
    (progn
      (do-bl-2 (strcat "frame-" NN) IP-I SS-F 0)
      (setq SS (ssadd (entlast) SS)) ))
  SS)
;==============================================================================
(defun get-data-2 (TL TL2)
  (if paucheck (princ "\nget-data-2"))
  (setq SS1  (ssadd)
        SS-F (ssadd)
        SS-S (ssadd)
        SS-V (ssadd)
        TYP  (get-typ TL)
        TYP  (cond ((eq TYP "GDL") "GDL-t")
                   ((eq TYP "   ") "GDL-b")
                   (t TYP))
        STR  (get-siz TL)
        STR  (cond ((eq STR "P19") "P10")
                   ((eq STR "")    "P34-")
                   ((member TYP '("GIL" "GIU" "GEL" "VIU")) (strcat STR "-"))
                   ;((member TYP '("VIU")) (strcat STR "_")) giu + 70 ex. klods
                   (t STR))
        PCO  (get-mat TL)
        PCO  (cond ((eq PCO "")(get-mat TL2))
                   (t PCO))
	GT   (cadr (assoc (substr PCO 3) U-GLASS-TIK))
        BRE  (caddr   (assoc STR USER-SIZ-LIS))
        HOJ  (cadddr  (assoc STR USER-SIZ-LIS)))
  (if paucheck (princ (list typ str gt bre hoj)))
  (if (and (member (substr STR 1 1) '("1" "2"))
	     (not (member TYP '("GVT" "_GVT"))) )
    (setq TYP (strcat TYP "_")))
)
;==============================================================================
(defun get-typli (TL / TPL A)
  (setq TPL '())
  (foreach A TL (setq TPL (append TPL (list (get-typ A)))))
  TPL)
;==============================================================================
(defun get-typlis (N A-X A-Y TL / TPL A I)
  (if paucheck (progn (princ "\nNY get-typlis")(princ (list N A-X A-Y TL))))
  (setq TPL '()
	AM  0
	A   (max
              (if (> (length TL) 0) 1 0)
              (/ (length TL) (* A-X (1+ A-Y))) )
	I   (if (eq (length TL) 1) 0 (* N A)) )
  (if paucheck (progn (princ "\t\t")(princ (list tpl am a i))))
  (repeat A
    (setq TPL (append TPL (list (get-typ (nth I TL)))))
    (setq I  (1+ I)))
  TPL)
;============================================================================
(defun red-mark (SS IP)
  (entmake (list '(0 . "CIRCLE")(list 10 (car IP)(cadr IP)(caddr IP))
           '(40 . 4.0)(cons 62 (atoi USER-C7)) (cons 8 USER-L7) ))
  (setq SS (ssadd (entlast) SS)
        SS (ent-l SS (list (+ -6.5 (car IP))(cadr IP)(caddr IP))
                     (list (+ 6.5 (car IP))(cadr IP)(caddr IP))
                     USER-L7 (atoi USER-C7) nil)
        SS (ent-l SS (list (car IP)(+ -6.5 (cadr IP))(caddr IP))
                     (list (car IP)(+ 6.5 (cadr IP))(caddr IP))
                     USER-L7 (atoi USER-C7) nil))
  SS)
;============================================================================
(defun rot-lin (P1 P2 PR ROT MIR / ENAM LIS)
  (command "_.line" P1 P2 ""
           "_.rotate" (entlast) "" PR (* -1 MIR ROT))
  (setq ENAM (entlast)
        LIS  (entget (entlast)))
  (command "_.erase" ENAM "")
  (list (cdr (assoc 10 LIS)) (cdr (assoc 11 LIS))))

;============================================================================
;*************************************************************************
;    
;*************************************************************************
;============================================================================
